import { _options, _type, _validate } from "./symbols";
import type { MakeRequired, RSA, RSN } from "./utils";
import type { Error, Path } from "./validate";
export declare type GuardResult = {
    valid: boolean;
    errors: Error[];
};
export declare type Validate = (val: unknown, path?: Path) => GuardResult;
export declare type GuardFunction<Type, Options extends RSA = RSN> = {
    [_validate]: Validate;
    [_type]: Type;
    [_options]: Partial<Options>;
};
export declare type Guard<Type, Options extends RSA = RSN> = GuardFunction<Type, RSN> & (<O extends Options>(options: Readonly<O>) => GuardFunction<Type, O>);
export declare function guard<Type, Options extends RSA = RSN>(name: string, fn: (val: unknown, options: Partial<Options>) => boolean, handleOptions?: {
    [K in keyof Options]-?: (val: Type, o: NonNullable<Options[K]>, options: MakeRequired<Options, K>) => boolean;
}): Guard<Type, Options>;
