"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const guard_1 = require("./guard");
const vality_1 = require("./vality");
vality_1.vality.string = (0, guard_1.guard)("string", val => typeof val === "string", {
    minLength: (val, o) => val.length >= o,
    maxLength: (val, o) => val.length <= o,
});
vality_1.vality.number = (0, guard_1.guard)("number", (val, o) => {
    let valid = typeof val === "number";
    if (o.allowNonFinite !== true)
        valid && (valid = Number.isFinite(val));
    return valid;
}, {
    min: (val, o) => val >= o,
    max: (val, o) => val <= o,
    allowNonFinite: val => true,
});
vality_1.vality.boolean = (0, guard_1.guard)("boolean", val => typeof val === "boolean");
vality_1.vality.literal = lit => (0, guard_1.guard)("literal", val => val === lit);
vality_1.vality.relation = () => (0, guard_1.guard)("relation", val => typeof val === "number" && val > 0 && val % 1 === 0);
