import type { Guard, GuardFunction, Validate } from "./guard";
import type { Valit } from "./valit";
export declare type RSA = Record<string, any>;
export declare type RSN = Record<string, never>;
export declare type RSE = {
    [K: string]: Eny;
};
export declare type MaybeArray<T> = T | T[];
export declare type Primitive = string | number | boolean;
export declare type _Eny = Primitive | Guard<Primitive, RSA> | GuardFunction<Primitive, RSA> | (() => RSE) | RSE;
export declare type Eny = MaybeArray<_Eny> | Readonly<MaybeArray<_Eny>>;
/**
 * Make all properties in T required whose key is assignable to K
 */
export declare type MakeRequired<T extends RSA, K extends keyof T> = {
    [KK in keyof _MakeRequired<T, K>]: _MakeRequired<T, K>[KK];
};
declare type _MakeRequired<T extends RSA, K extends keyof T> = Required<Pick<T, K>> & Pick<T, Exclude<keyof T, K>>;
export declare function assert<T>(val: any, condition?: boolean): asserts val is T;
declare type EnyToGuard<T> = T extends [infer U] ? Valit<U[], any> : T extends [...infer U] ? Valit<U, any> : T extends Primitive ? Guard<T> : T extends Guard<any> ? T : T extends () => infer U ? Guard<U> : Guard<T>;
export declare function enyToGuard(eny: Eny): EnyToGuard<Eny>;
export declare function enyToGuardFn(v: Eny): Validate;
export declare function flat<T>(arr: T[][]): T[];
export {};
