import type { GuardFunction, GuardResult } from "./guard";
import { MakeRequired, RSA, RSN } from "./utils";
import type { Path } from "./validate";
export declare const _valit: unique symbol;
export declare type ValitFunction<V, Options extends RSA = RSN> = {
    [_valit]?: any;
} & GuardFunction<V, Options>;
export declare type Valit<V, Options extends RSA = RSN> = (<O extends Options>(options: Partial<O>) => ValitFunction<V, O>) & ValitFunction<V>;
export declare function valit<Arg extends any[], Type, Options extends RSA = RSN>(name: string, fn: (...args: Arg) => (val: unknown, path: Path, options: Partial<Options>) => GuardResult, handleOptions?: {
    [K in keyof Options]-?: (val: Type, o: NonNullable<Options[K]>, options: MakeRequired<Options, K>) => boolean;
}): (...args: Arg) => Valit<Type, Options>;
