"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.valit = exports._valit = void 0;
const symbols_1 = require("./symbols");
// This symbol is used to distingush between a guard and a valit
exports._valit = Symbol("valit");
function valit(name, fn, handleOptions) {
    return (...args) => {
        const fnWithValit = (val, path = []) => {
            return fn(...args)(val, path, {});
        };
        return Object.assign((options) => {
            const fnWithValitWithOptions = (val, path = []) => {
                const valid = fn(...args)(val, path, options);
                if (!valid.valid)
                    return valid;
                if (handleOptions === undefined)
                    return { valid: true, errors: [] };
                const keysWithError = Object.keys(options).filter(k => !handleOptions[k](val, options[k], options));
                return {
                    valid: keysWithError.length === 0,
                    errors: keysWithError.map(k => ({
                        message: `vality.${name}.options.${k}`,
                        path,
                        options,
                        val,
                    })),
                };
            };
            return Object.assign({
                [symbols_1._validate]: fnWithValitWithOptions,
                [symbols_1._type]: undefined,
                [symbols_1._options]: options,
            });
        }, {
            [symbols_1._validate]: fnWithValit,
            [symbols_1._type]: undefined,
            [symbols_1._options]: {},
        });
    };
}
exports.valit = valit;
